--Trainee Script 0.9 for Alice Beta 0.9 by SEKoner

--Press F1 = Godmode ON
--Press F2 = Add Armour
--Press F3 = Clear Wanted Level
--Press F4 = Repair Car
--Press F5 = Save Game
--Press F6 = Add Money 3754$
--Press F7 = Unlock Bridges
--Press F8 = Reset Cheat-Count
--Press F9 = Give Weapons
--Press ALT+F1 = = Godmode OFF
--Press ALT+F4 = = Exit Game
--Press CTRL+1 = = Spawn Police Car 2
--Press CTRL+2 = = Spawn Schafter
--Press CTRL+3 = = Spawn Sentinel
--Press CTRL+4 = = Spawn Feltzer
--Press CTRL+5 = = Spawn FBI Buffalo
--Press CTRL+6 = = Spawn Annihilator

-- Carspawn functions from Alexander Blade

function GetSpawnCoords()
  PushInt(PLAYER_CHAR)
  PushFloat(0.0)
  PushFloat(5.0)
  PushFloat(0.0)
  PushVarPtr()
  PushVarPtr()
  PushVarPtr()
  CallNative("GET_OFFSET_FROM_CHAR_IN_WORLD_COORDS")
  X = GetFloatParam(4)
  Y = GetFloatParam(5)
  Z = GetFloatParam(6) 
end
		
function SpawnCar(name)
  local p = {} 
  GET_PLAYER_CHAR(GET_PLAYER_ID(), p)
  local PLAYER_CHAR = p.a
  if PLAYER_CHAR <= 0 then return end
  local hash = GET_HASH_KEY(name)
  REQUEST_MODEL(hash)
  while HAS_MODEL_LOADED(hash) == 0 do Wait(100) end  
  local x = {}  local y = {}  local z = {}
  GET_CHAR_COORDINATES(PLAYER_CHAR, x, y, z)
  GET_OFFSET_FROM_CHAR_IN_WORLD_COORDS(PLAYER_CHAR, 0, 5.5, 0, x, y, z)
  local c = {}
  CREATE_CAR(hash, x.b, y.b, z.b, c, true)
  local colour1 = {}  local colour2 = {}
  GENERATE_RANDOM_INT_IN_RANGE(0, 255, colour1)
  GENERATE_RANDOM_INT_IN_RANGE(0, 255, colour2)
  CHANGE_CAR_COLOUR(c.a, colour1.a, colour2.a)
  GENERATE_RANDOM_INT_IN_RANGE(0, 255, colour1)
  GENERATE_RANDOM_INT_IN_RANGE(0, 255, colour2) 
  SET_EXTRA_CAR_COLOURS(c.a, colour1.a, colour2.a)
  SET_CAR_PROOFS(c.a, 1, 1, 1, 1, 1);
  SET_VEH_HAS_STRONG_AXLES(c.a, 1);
  SET_CAR_CAN_BE_DAMAGED(c.a, 0);
  SET_CAR_ENGINE_ON(c.a, 1, 1);
  SET_CAN_BURST_CAR_TYRES(c.a, 0);
  SET_CAR_HEALTH(c.a, 99999.0);
  PRINT_HELP(name)
  MARK_MODEL_AS_NO_LONGER_NEEDED(hash)
  Wait(2000)
  MARK_CAR_AS_NO_LONGER_NEEDED(c)
end

-- Save Game function

function SaveGame()
  local p = {} 
  GET_PLAYER_CHAR(GET_PLAYER_ID(), p)
  if (p.a <= 0) then return end
  if IS_CHAR_IN_ANY_CAR(p.a) == 1 then return end
  local SAVEDONE
  local TIMER
  SAVEDONE = 0
  TIMER = 0
  ACTIVATE_SAVE_MENU()
  Wait(1000)
  while (SAVEDONE == 0) and (TIMER < 10000) do
    TIMER = TIMER + 100
	Wait(100)
	SAVEDONE = DID_SAVE_COMPLETE_SUCCESSFULLY()
  end
end

-- Weapon function

function GiveWeapon(Char, Num)
  if HAS_CHAR_GOT_WEAPON(Char, Num) == 1 
    then SET_CHAR_AMMO(Char, Num, 200)
    else GIVE_WEAPON_TO_CHAR(Char, Num, 200, 0)
  end	
end	

function GiveWeapons()
  local PLAYER_ID
  PLAYER_ID = GET_PLAYER_ID()
  if (PLAYER_ID < 0) then return end
  local p = {}
  GET_PLAYER_CHAR(PLAYER_ID, p)
  GiveWeapon(p.a, 2)
  GiveWeapon(p.a, 5)
  GiveWeapon(p.a, 9)
  GiveWeapon(p.a, 11)
  GiveWeapon(p.a, 13)
  GiveWeapon(p.a, 14)
  GiveWeapon(p.a, 16)
  GiveWeapon(p.a, 18)
  PRINT_STRING_WITH_LITERAL_STRING_NOW("STRING","Weapons added",1000,1)
end

-- God Mode stuff

function MakeGod()
  local PLAYER_ID
  local PLAYER_CHAR
  PLAYER_ID = GET_PLAYER_ID()
  if (PLAYER_ID < 0) then return end
  local p = {}
  GET_PLAYER_CHAR(PLAYER_ID, p)
  PLAYER_CHAR = p.a
  SET_CHAR_HEALTH(PLAYER_CHAR,200)
  Wait(300)
  SET_PLAYER_INVINCIBLE(PLAYER_ID, true)
  SET_PLAYER_NEVER_GETS_TIRED(PLAYER_ID, true)
  PRINT_STRING_WITH_LITERAL_STRING_NOW("STRING","God Mode ON",1000,1)
end

function EndGod()
  local PLAYER_ID
  PLAYER_ID = GET_PLAYER_ID()
  local p = {} 
  GET_PLAYER_CHAR(GET_PLAYER_ID(), p)
  if (PLAYER_ID < 0) then return end
  SET_PLAYER_INVINCIBLE(PLAYER_ID, false)
  SET_PLAYER_NEVER_GETS_TIRED(PLAYER_ID, false)
  PRINT_STRING_WITH_LITERAL_STRING_NOW("STRING","God Mode OFF",1000,1)
end

-- Clear actual wanted level

function ClearWantedLevel()
  local PLAYER_ID
  PLAYER_ID = GET_PLAYER_ID()
  if (PLAYER_ID < 0) then return end
  CLEAR_WANTED_LEVEL(PLAYER_ID)
  PRINT_STRING_WITH_LITERAL_STRING_NOW("STRING","Wanted Level Cleared",1000,1)
  Wait(1000)
end

-- Repair Car functions

function SetHazardlights(carIndex)
 SET_VEH_INDICATORLIGHTS(carIndex,1)
end

function SetHazardlights1(carIndex)
 SET_VEH_INDICATORLIGHTS(carIndex,0)
end

function RepairCar(playerCar)
  local PLAYER_ID
  local PLAYER_CHAR
  local PLAYER_CAR
  PLAYER_ID = GET_PLAYER_ID()
  if (PLAYER_ID < 0) then return end
  local p = {}
  GET_PLAYER_CHAR(PLAYER_ID, p)
  PLAYER_CHAR = p.a
  local YourCar = {}
  _GET_CAR_CHAR_IS_USING(PLAYER_CHAR, YourCar) -- check if the player is in a car
  PLAYER_CAR = YourCar.a
  if (PLAYER_CAR ~= 0) then
    FIX_CAR(PLAYER_CAR)
  end
  PRINT_STRING_WITH_LITERAL_STRING_NOW("STRING","Car repaired",1000,1)
   SetHazardlights(PLAYER_CAR)
   Wait(500)
   SetHazardlights1(PLAYER_CAR)
   Wait(500)
   SetHazardlights(PLAYER_CAR)
   Wait(500)
   SetHazardlights1(PLAYER_CAR)
   Wait(500)
   SetHazardlights(PLAYER_CAR)
   Wait(500)
   SetHazardlights1(PLAYER_CAR)
   Wait(500)
   SetHazardlights(PLAYER_CAR)
   Wait(500)
   SetHazardlights1(PLAYER_CAR)
   Wait(300)
end

-- diverse small funtions

function GiveMeMoney()
  local PLAYER_ID
  PLAYER_ID = GET_PLAYER_ID()
  ADD_SCORE(PLAYER_ID,3754)
  PRINT_STRING_WITH_LITERAL_STRING_NOW("STRING","Money added",1000,1)
  Wait(300)
end

function UnlockBridges()
  SET_INT_STAT(363,3)
  PRINT_STRING_WITH_LITERAL_STRING_NOW("STRING","Bridges unlocked",1000,1)
  Wait(300)
end

function GiveArmour()
  local PLAYER_ID
  local PLAYER_CHAR
  PLAYER_ID = GET_PLAYER_ID()
  if (PLAYER_ID < 0) then return end
  local p = {}
  GET_PLAYER_CHAR(PLAYER_ID, p)
  PLAYER_CHAR = p.a
  ADD_ARMOUR_TO_CHAR(PLAYER_CHAR,200)
  PRINT_STRING_WITH_LITERAL_STRING_NOW("STRING","Armour added",1000,1)
  Wait(300)
end

function ResetCheatCount()
  SET_INT_STAT(259,0)
  PRINT_STRING_WITH_LITERAL_STRING_NOW("STRING","Cheats-Stat resetted",1000,1)
  Wait(300)
end

-- Key settings and start

function main()
  Wait(1000)
  while true do
     Wait(100) 
	  -- F1 ----------------------------- 
   	  if (IsKeyPressed(112) == 1) then
   	     if (IsKeyPressed(18) == 1) then
   	        EndGod()
   	     else
   	        MakeGod()
   	     end
   	  end
	  -- F2 ----------------------------- 
	  if (IsKeyPressed(113) == 1) then GiveArmour() end
	  -- F3 ----------------------------- 
	  if (IsKeyPressed(114) == 1) then ClearWantedLevel() end
	  -- F4 ----------------------------- 
	  if (IsKeyPressed(115) == 1) then RepairCar() end
	  -- F5 ----------------------------- 
          if (IsKeyPressed(116) == 1) then SaveGame() end
	  -- F6 ----------------------------- 
          if (IsKeyPressed(117) == 1) then GiveMeMoney() end
	  -- F7 ----------------------------- 
          if (IsKeyPressed(118) == 1) then UnlockBridges() end
	  -- F8 ----------------------------- 
	  if (IsKeyPressed(119) == 1) then ResetCheatCount() end
	  -- F9 ----------------------------- 
          if (IsKeyPressed(120) == 1) then GiveWeapons() end
	  -- F10 ---------------------------- 
          --if (IsKeyPressed(121) == 1) then BlinkendeKarre() end
	  -- F11 ---------------------------- 
          --if (IsKeyPressed(122) == 1) then SpawnCar("police2") end
	  -- F12 ---------------------------- 
          --if (IsKeyPressed(123) == 1) then SpawnCar("annihilator") end
	  -- CTRL & * -----------------------
   	  if (IsKeyPressed(17) == 1) then
   	     if (IsKeyPressed(49) == 1) then 
	         SpawnCar("police2")
             end
   	     if (IsKeyPressed(50) == 1) then 
	         SpawnCar("schafter")
             end
   	     if (IsKeyPressed(51) == 1) then 
	         SpawnCar("sentinel")
             end
   	     if (IsKeyPressed(52) == 1) then 
	         SpawnCar("feltzer")
             end
   	     if (IsKeyPressed(53) == 1) then 
	         SpawnCar("fbi")
             end
   	     if (IsKeyPressed(54) == 1) then 
	         SpawnCar("annihilator")
             end
          end
    Wait(1000)	
  end	
end

-- start
main();


